Treetable

Vue Bootstrap 5 Treetable plugin

The Treetable component can render your data with a simple HTML. You simply create a HTML markup for your table nested within a div tag with a "treetable" class - you can customize your table later by adding data-mdb-attributes to the wrapper.

Note: Read the API tab to find all available options and advanced customization


Basic example

Create default Treetable with MDBTreetable component. Pass table headers row to a head slot and table body rows to a default slot. Adding data-depth attribute to a row element indicates it is another nest. Each deeper nest's depth should be incremented by one.

Name Size Type
Personal 15mb Folder
index 5mb html
index 5mb html
my-cat 0mb webp
Documents 350mb Folder
Bill 200mb pdf
Newspapers mentions 50mb PDF
Ebooks 100mb zip
Songs 30mb Folder
Ode to JS 10mb mp3
One more style 10mb mp3
Bjork-Its-Oh-So-Quiet 10mb mp3
Images 1,5gb Folder
Album-cover 500mb jpeg
Naruto-background 500mb png
Sasuke-background 500mb webp
        
            
            <template>
              <MDBTreetable class="d-flex w-100">
                <template #head>
                  <tr>
                    <th scope="col">Name</th>
                    <th scope="col">Size</th>
                    <th scope="col">Type</th>
                  </tr>
                </template>
                <template>
                  <tr data-depth="1">
                    <td>Personal</td>
                    <td>15mb</td>
                    <td>Folder</td>
                  </tr>
                  <tr>
                    <td>index</td>
                    <td>5mb</td>
                    <td>html</td>
                  </tr>
                  <tr>
                    <td>index</td>
                    <td>5mb</td>
                    <td>html</td>
                  </tr>
                  <tr>
                    <td>my-cat</td>
                    <td>0mb</td>
                    <td>jpg</td>
                  </tr>
                  <tr data-depth="2">
                    <td>Documents</td>
                    <td>350mb</td>
                    <td>Folder</td>
                  </tr>
                  <tr>
                    <td>Bill</td>
                    <td>200mb</td>
                    <td>pdf</td>
                  </tr>
                  <tr>
                    <td>Newspapers mentions</td>
                    <td>50mb</td>
                    <td>PDF</td>
                  </tr>
                  <tr>
                    <td>Ebooks</td>
                    <td>100mb</td>
                    <td>zip</td>
                  </tr>
                  <tr data-depth="2">
                    <td>Songs</td>
                    <td>30mb</td>
                    <td>Folder</td>
                  </tr>
                  <tr>
                    <td>Ode to JS</td>
                    <td>10mb</td>
                    <td>mp3</td>
                  </tr>
                  <tr>
                    <td>One more style</td>
                    <td>10mb</td>
                    <td>mp3</td>
                  </tr>
                  <tr>
                    <td>Bjork-Its-Oh-So-Quiet</td>
                    <td>10mb</td>
                    <td>mp3</td>
                  </tr>
                  <tr data-depth="1">
                    <td>Images</td>
                    <td>1,5gb</td>
                    <td>Folder</td>
                  </tr>
                  <tr>
                    <td>Album-cover</td>
                    <td>500mb</td>
                    <td>jpeg</td>
                  </tr>
                  <tr>
                    <td>Naruto-background</td>
                    <td>500mb</td>
                    <td>png</td>
                  </tr>
                  <tr>
                    <td>Sasuke-background</td>
                    <td>500mb</td>
                    <td>jpg</td>
                  </tr>
                </template>
              </MDBTreetable>
            </template>
          
        
    
        
            
            <script>
              import { MDBTreetable } from "mdb-vue-treetable";
              
              export default {
                components: {
                  MDBTreetable
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreetable } from "mdb-vue-treetable";
            </script>
          
        
    

Structure example

Use structure property to create a MDBTreetable from the JavaScript structure.

Name Size Type
Personal 15mb Folder
index 5mb html
index 5mb html
my-cat 0mb webp
Documents 350mb Folder
Bill 200mb pdf
Newspapers mentions 50mb PDF
Ebooks 100mb zip
Songs 30mb Folder
Ode to JS 10mb mp3
One more style 10mb mp3
Bjork-Its-Oh-So-Quiet 10mb mp3
Images 1,5gb Folder
Album-cover 500mb jpeg
Naruto-background 500mb png
Sasuke-background 500mb webp
        
            
            <template>
              <MDBTreetable
                class="d-flex w-100"
                :structure="{
                  cols: ['Name', 'Size', 'Type'],
                  rows: [
                    {
                      data: ['Personal', '15mb', 'Folder'],
                      children: [
                        {
                          data: ['index', '5mb', 'html'],
                        },
                        {
                          data: ['index', '5mb', 'html'],
                        },
                        {
                          data: ['my-cat', '0mb', 'jpg'],
                        },
                        {
                          data: ['Documents', '350mb', 'Folder'],
                          children: [
                            {
                              data: ['Bill', '200mb', 'PDF'],
                            },
                            {
                              data: ['Newspapers mentions', '50mb', 'PDF'],
                            },
                            {
                              data: ['Ebooks', '100mb', 'zip'],
                            },
                          ],
                        },
                        {
                          data: ['Songs', '30mb', 'Folder'],
                          children: [
                            {
                              data: ['Ode to JS', '10mb', 'mp3'],
                            },
                            {
                              data: ['One more style', '10mb', 'mp3'],
                            },
                            {
                              data: ['Bjork-Its-Oh-So-Quiet', '10mb', 'mp3'],
                            },
                          ],
                        },
                      ],
                    },
                    {
                      data: ['Images', '1,5gb', 'Folder'],
                      children: [
                        {
                          data: ['Album-cover', '500mb', 'jpeg'],
                        },
                        {
                          data: ['Naruto-background', '500mb', 'png'],
                        },
                        {
                          data: ['Sasuke-background', '500mb', 'webp'],
                        },
                      ],
                    },
                  ],
                }"
            />
            </template>
          
        
    
        
            
            <script>
              import { MDBTreetable } from "mdb-vue-treetable";
              
              export default {
                components: {
                  MDBTreetable
                }
              };
            </script>
          
        
    
        
            
            <script setup lang="ts">
              import { MDBTreetable } from "mdb-vue-treetable";
            </script>
          
        
    

TAILWIND

GIFT for 2026

Purchase anything during the New Years Sale and get a Tailwind UI kit gift!

Treetable - API


Import

        
            
          <script>
            import { MDBTreetable } from "mdb-vue-treetable";
          </script>
        
        
    

Properties

Name Type Default Description
structure Object - Setup structure of tree elements.
tag String 'div' Sets component wrapper tag.

Methods

Name Description
collapseAll Collapses every nested row in table.
expandAll Expands every nested row in table.
        
            
        <template>
          <MDBBtn color="primary" @click="treetableRef?.collapseAll()"
            >Collapse all</MDBBtn
          >
          <MDBTreetable class="d-flex w-100" ref="treetableRef">
            <template #head>
              <tr>
                <th scope="col">Name</th>
                <th scope="col">Size</th>
                <th scope="col">Type</th>
              </tr>
            </template>
            <template>
              <tr data-depth="1">
                <td>Personal</td>
                <td>15mb</td>
                <td>Folder</td>
              </tr>
              <tr>
                <td>index</td>
                <td>5mb</td>
                <td>html</td>
              </tr>
              <tr>
                <td>index</td>
                <td>5mb</td>
                <td>html</td>
              </tr>
              <tr>
                <td>my-cat</td>
                <td>0mb</td>
                <td>jpg</td>
              </tr>
              <tr data-depth="2">
                <td>Documents</td>
                <td>350mb</td>
                <td>Folder</td>
              </tr>
              <tr>
                <td>Bill</td>
                <td>200mb</td>
                <td>pdf</td>
              </tr>
              <tr>
                <td>Newspapers mentions</td>
                <td>50mb</td>
                <td>PDF</td>
              </tr>
              <tr>
                <td>Ebooks</td>
                <td>100mb</td>
                <td>zip</td>
              </tr>
              <tr data-depth="2">
                <td>Songs</td>
                <td>30mb</td>
                <td>Folder</td>
              </tr>
              <tr>
                <td>Ode to JS</td>
                <td>10mb</td>
                <td>mp3</td>
              </tr>
              <tr>
                <td>One more style</td>
                <td>10mb</td>
                <td>mp3</td>
              </tr>
              <tr>
                <td>Bjork-Its-Oh-So-Quiet</td>
                <td>10mb</td>
                <td>mp3</td>
              </tr>
              <tr data-depth="1">
                <td>Images</td>
                <td>1,5gb</td>
                <td>Folder</td>
              </tr>
              <tr>
                <td>Album-cover</td>
                <td>500mb</td>
                <td>jpeg</td>
              </tr>
              <tr>
                <td>Naruto-background</td>
                <td>500mb</td>
                <td>png</td>
              </tr>
              <tr>
                <td>Sasuke-background</td>
                <td>500mb</td>
                <td>jpg</td>
              </tr>
            </template>
          </MDBTreetable>
        </template>
        
        
    
        
            
        <script>
          import { MDBTreetable } from "mdb-vue-treetable";
          import { MDBBtn } from "mdb-vue-ui-kit";
          import { ref } from "vue";
          export default {
            components: {
              MDBTreetable,
              MDBBtn,
            },
            setup() {
              const treetableRef = ref();
          
              return {
                treetableRef,
              };
            },
          };
        </script>
        
        
    
        
            
        <script setup lang="ts">
          import { MDBTreetable } from "mdb-vue-treetable";
          import { MDBBtn } from "mdb-vue-ui-kit";
          import { ref } from "vue";
          
          const treetableRef = ref<InstanceType<typeof MDBTreetable> | null>(null);
        </script>
        
        
    

Events

Name Description
collapse This event fires when a user collapses a nest. Collapsed row is available with id property of the event (includes also all of the row's children when collapse parent).
collapseAll This event fires when a user collapses all of a nestes using collapseAll method.
expand This event fires when a user expandes a nest. Expanded row is available with id property of the event.
expandAll This event fires when a user expandes all of a nestes using expandAll method.
        
            
          <template>
            <MDBTreetable  @collapse="doSomething" >...</MDBTreetable >
          </template>

Treetable

Angular Bootstrap 5 Treetable plugin

The Treetable plugin can render your data with a simple HTML. You simply create a HTML markup for your table nested within a div tag with a "treetable" class.

Note: Read the API tab to find all available options and advanced customization


Basic example

Create default Treetable by appending a table element into a div with a .treetable class. Add MdbTreeTable directive to table element and MdbTreeTableRow directive to tr element. Use dataSource input to set up the table. Adding children property to dataSource will create a nested row structure.

Name Size Type
Personal 15mb Folder
index 5mb html
index 5mb html
my-cat 0mb webp
Documents 350mb Folder
Bill 200mb pdf
Newspapers mentions 50mb PDF
Ebooks 100mb zip
Songs 30mb Folder
Ode to JS 10mb mp3
One more style 10mb mp3
Bjork-Its-Oh-So-Quiet 10mb mp3
Images 1,5gb Folder
Album-cover 500mb jpeg
Naruto-background 500mb png
Sasuke-background 500mb webp
        
            
        <div class="treetable d-flex w-100">
          <table class="table" mdbTreeTable #treeTable="mdbTreeTable" [dataSource]="dataSource">
            <thead>
              <tr>
                <th scope="col" *ngFor="let header of headers">{{ header | titlecase }}</th>
              </tr>
            </thead>
            <tbody>
              <tr *ngFor="let rowData of treeTable.data" scope="row" [mdbTreeTableRow]="rowData">
                <td>
                  {{ rowData.name }}
                </td>
                <td>
                  {{ rowData.size }}
                </td>
                <td>
                  {{ rowData.type }}
                </td>
              </tr>
            </tbody>
          </table>
        </div>
        
        
    
        
            
        import { Component } from '@angular/core';

        interface FileType {
          name: string;
          size: string;
          type: string;
          children?: FileType[];
        }

        @Component({
          selector: 'app-root',
          templateUrl: './app.component.html',
        })
        export class AppComponent {
          headers = ['Name', 'Size', 'Type'];
          dataSource: FileType[] = [
            {
              name: 'Personal',
              size: '15mb',
              type: 'Folder',
              children: [
                {
                  name: 'index',
                  size: '5mb',
                  type: 'html',
                },
                {
                  name: 'index',
                  size: '5mb',
                  type: 'html',
                },
                {
                  name: 'my-cat',
                  size: '0mb',
                  type: 'webp',
                },
                {
                  name: 'Documents',
                  size: '350mb',
                  type: 'Folder',
                  children: [
                    {
                      name: 'Bill',
                      size: '200mb',
                      type: 'pdf',
                    },
                    {
                      name: 'Newspapers mentions',
                      size: '50mb',
                      type: 'PDF',
                    },
                    {
                      name: 'Ebooks',
                      size: '100mb',
                      type: 'zip',
                    },
                  ],
                },
                {
                  name: 'Songs',
                  size: '30mb',
                  type: 'Folder',
                  children: [
                    {
                      name: 'Ode to JS',
                      size: '10mb',
                      type: 'mp3',
                    },
                    {
                      name: 'One more style',
                      size: '10mb',
                      type: 'mp3',
                    },
                    {
                      name: 'Bjork-Its-Oh-So-Quiet',
                      size: '10mb',
                      type: 'mp3',
                    },
                  ],
                },
              ],
            },
            {
              name: 'Images',
              size: '1,5gb',
              type: 'Folder',
              children: [
                {
                  name: 'Album-cover',
                  size: '5mb',
                  type: 'html',
                },
                {
                  name: 'Naruto-background',
                  size: '500mb',
                  type: 'jpeg',
                },
                {
                  name: 'Sasuke-background',
                  size: '500mb',
                  type: 'png',
                },
              ],
            },
          ];
        };
      
        
    

TAILWIND

GIFT for 2026

Purchase anything during the New Years Sale and get a Tailwind UI kit gift!

TreeTable - API


Installation

To install and configure the plugin follow our Plugins Installation Guide. Please remember to update all the plugin names and import paths. You can find all the necessary information in the Import section.

        
            
     npm i git+https://oauth2:ACCESS_TOKEN@git.mdbootstrap.com/mdb/angular/mdb5/plugins/prd/treetable
     
        
    

Import

        
            
          import { MdbTreeTableModule } from 'mdb-angular-treetable';
          …
          @NgModule ({
            ...
            imports: [MdbTreeTableModule],
            ...
          })
        
        
    
        
            
        @import 'mdb-angular-treetable/scss/treetable.scss';
      
        
    

Inputs

MdbTreeTableDirective

Name Type Default Description
dataSource T[] [] Data for treeTable construction.

Outputs

MdbTreeTableDirective

Name Description
collapse This event fires when a user collapses a row. You can access the data of collapsed row.
expand This event fires when a user expands a row. You can access the data of expanded row.

Methods

MdbTreeTableDirective

Name Description
collapseAll Collapses all rows
expandAll Expands all rows

Treetable

TreeTable - Bootstrap 5 & Material Design plugin

Responsive Treetable built with the latest Bootstrap 5.

Note: Read the API tab to find all available options and advanced customization


Basic example

Create default Treetable by using MDBTreeTable component and adding MDBTreeTableHead and MDBTreeTableBody with MDBTreeTableItem inside. Adding depth property to MDBTreeTableItem element indicates another nest.

Name Size Type
Personal 15mb Folder
index 5mb html
index 5mb html
my-cat 0mb webp
Documents 350mb Folder
Bill 200mb pdf
Newspapers mentions 50mb PDF
Ebooks 100mb zip
Songs 30mb Folder
Ode to JS 10mb mp3
One more style 10mb mp3
Bjork-Its-Oh-So-Quiet 10mb mp3
Images 1,5gb Folder
Album-cover 500mb jpeg
Naruto-background 500mb png
Sasuke-background 500mb webp
        
            
        import React from 'react';
        import { MDBTreeTable, MDBTreeTableItem, MDBTreeTableHead, MDBTreeTableBody } from 'mdb-react-treetable';
        
        export default function App() {
          return (
            <MDBTreeTable>
              <MDBTreeTableHead heads={['Name', 'Size', 'Type']} />
              <MDBTreeTableBody>
                <MDBTreeTableItem values={['Personal', '15mb', 'Folder']} depth={1} />
                <MDBTreeTableItem values={['index', '5mb', 'html']} depth={2} />
                <MDBTreeTableItem values={['index', '5mb', 'html']} depth={2} />
                <MDBTreeTableItem values={['my-cat', '0mb', 'webp']} depth={2} />
                <MDBTreeTableItem values={['Documents', '350mb', 'Folder']} depth={2} />
                <MDBTreeTableItem values={['Bill', '200mb', 'PDF']} depth={3} />
                <MDBTreeTableItem values={['Newspapers mentions', '50mb', 'PDF']} depth={3} />
                <MDBTreeTableItem values={['Ebooks', '100mb', 'zip']} depth={3} />
                <MDBTreeTableItem values={['Songs', '30mb', 'Folder']} depth={2} />
                <MDBTreeTableItem values={['Ode to JS', '10mb', 'mp3']} depth={3} />
                <MDBTreeTableItem values={['One more style', '10mb', 'mp3']} depth={3} />
                <MDBTreeTableItem values={['Bjork-Its-Oh-So-Quiet', '10mb', 'mp3']} depth={3} />
                <MDBTreeTableItem values={['Images', '1.5gb', 'Folder']} depth={1} />
                <MDBTreeTableItem values={['Album-cover', '500mb', 'jpeg']} depth={2} />
                <MDBTreeTableItem values={['Naruto-background', '500mb', 'png']} depth={2} />
                <MDBTreeTableItem values={['Sasuke-background', '500mb', 'webp']} depth={2} />
              </MDBTreeTableBody>
            </MDBTreeTable>
          );
        }        
        
        
    

TAILWIND

GIFT for 2026

Purchase anything during the New Years Sale and get a Tailwind UI kit gift!

Treetable - API


Import

        
            
          import { MDBTreeTable, MDBTreeTableItem, MDBTreeTableHead, MDBTreeTableBody } from 'mdb-react-treetable';
          
        
    

Properties

MDBTreeTable

Name Type Default Description Example
className String '' Add custom class to MDBTreeTable <MDBTreeTable className='custom-class'> ... </MDBTreeTable>

MDBTreeTableHead

Name Type Default Description Example
heads (string | number)[] Defines the table headers <MDBTreeTableHead heads={['Name', 'Size', 'Type']}> ... </MDBTreeTableHead>

MDBTreeTableItem

Name Type Default Description Example
depth number 1 Indicates nest depth <MDBTreeTableItem depth={2} />
values (string | number)[] Defines row values in MDBTreeTableItem <MDBTreeTableItem values={['Personal', '15mb', 'Folder']} />